
set( artdaq_demo_VERSION 2.08.02 )
set( artdaq_demo_UPS_VERSION v2_08_02 )


####### Expanded from @PACKAGE_INIT@ by configure_package_config_file() #######
####### Any changes to this file will be overwritten by the next CMake run ####
####### The input file was product-config.cmake.in                            ########

get_filename_component(PACKAGE_PREFIX_DIR "${CMAKE_CURRENT_LIST_DIR}/../../../../../../" ABSOLUTE)

macro(set_and_check _var _file)
  set(${_var} "${_file}")
  if(NOT EXISTS "${_file}")
    message(FATAL_ERROR "File or directory ${_file} referenced by variable ${_var} does not exist !")
  endif()
endmacro()

macro(check_required_components _NAME)
  foreach(comp ${${_NAME}_FIND_COMPONENTS})
    if(NOT ${_NAME}_${comp}_FOUND)
      if(${_NAME}_FIND_REQUIRED_${comp})
        set(${_NAME}_FOUND FALSE)
      endif()
    endif()
  endforeach()
endmacro()

####################################################################################


## find_ups_product directives
## remember that these are minimum required versions
    find_ups_product( artdaq v0_04_02 )
    find_ups_boost( v1_53_0 )
    find_ups_product( TRACE v3_03_00 )
    find_ups_product( art v1_08_10 )
    find_ups_product( cppunit v1_12_1a )
    find_ups_product( gccxml v0_9_20140718a )
    find_ups_product( clhep v2_2_0_3 )
    find_ups_product( cetpkgsupport v1_08_03 )
    find_ups_product( cetlib v1_08_00 )
    find_ups_product( cpp0x v1_03_02 )
    find_ups_product( fhiclcpp v3_09_00 )
    find_ups_product( sqlite v3_07_15_00 )
    find_ups_product( messagefacility v1_14_01 )
    find_ups_root( v5_34_20 )
    find_ups_product( tbb v4_1 )
    find_ups_product( artdaq_core v1_03_01 )
    find_ups_product( artdaq_utilities v1_00_00 )
    find_ups_product( xmlrpc_c v1_25_18 )
    find_ups_product( artdaq_core_demo v0_00_01 )


## find_library directives
    if( NOT SQLITE3 )
      cet_find_library( SQLITE3 NAMES sqlite3_ups PATHS ENV SQLITE_LIB NO_DEFAULT_PATH )
    endif()
    if( NOT CLHEP )
      cet_find_library( CLHEP NAMES CLHEP PATHS ENV CLHEP_LIB_DIR NO_DEFAULT_PATH )
    endif()
    if( NOT CPPUNIT )
      cet_find_library( CPPUNIT NAMES cppunit PATHS ENV CPPUNIT_LIB NO_DEFAULT_PATH )
    endif()
      set( ARTDAQ-DEMO_PRODUCTS  $ENV{ARTDAQ_DEMO_LIB}/libartdaq-demo_Products.so )
      set( ARTDAQ-DEMO_PRODUCTS_DICT  $ENV{ARTDAQ_DEMO_LIB}/libartdaq-demo_Products_dict.so )
      set( ARTDAQ-DEMO_ARTMODULES  $ENV{ARTDAQ_DEMO_LIB}/libartdaq-demo_ArtModules.so )
      set( ARTDAQ-DEMO_ARTMODULES_BASELINE_MODULE  $ENV{ARTDAQ_DEMO_LIB}/libartdaq-demo_ArtModules_Baseline_module.so )
      set( ARTDAQ-DEMO_ARTMODULES_CONVERTER_MODULE  $ENV{ARTDAQ_DEMO_LIB}/libartdaq-demo_ArtModules_Converter_module.so )
      set( ARTDAQ-DEMO_ARTMODULES_SUMMER_MODULE  $ENV{ARTDAQ_DEMO_LIB}/libartdaq-demo_ArtModules_Summer_module.so )
      set( ARTDAQ-DEMO_ARTMODULES_NTHEVENT_MODULE  $ENV{ARTDAQ_DEMO_LIB}/libartdaq-demo_ArtModules_NthEvent_module.so )
      set( ARTDAQ-DEMO_ARTMODULES_ARTDAQDEMOBUILDINFO_MODULE  $ENV{ARTDAQ_DEMO_LIB}/libartdaq-demo_ArtModules_ArtdaqDemoBuildInfo_module.so )
      set( ARTDAQ-DEMO_ARTMODULES_DATACHARACTERIZER_MODULE  $ENV{ARTDAQ_DEMO_LIB}/libartdaq-demo_ArtModules_DataCharacterizer_module.so )
      set( ARTDAQ-DEMO_ARTMODULES_EVENTDUMP_MODULE  $ENV{ARTDAQ_DEMO_LIB}/libartdaq-demo_ArtModules_EventDump_module.so )
      set( ARTDAQ-DEMO_ARTMODULES_TOYDUMP_MODULE  $ENV{ARTDAQ_DEMO_LIB}/libartdaq-demo_ArtModules_ToyDump_module.so )
      set( ARTDAQ-DEMO_ARTMODULES_ASCIIDUMP_MODULE  $ENV{ARTDAQ_DEMO_LIB}/libartdaq-demo_ArtModules_ASCIIDump_module.so )
      set( ARTDAQ-DEMO_ARTMODULES_COMPRESSIONCHECKER_MODULE  $ENV{ARTDAQ_DEMO_LIB}/libartdaq-demo_ArtModules_CompressionChecker_module.so )
      set( ARTDAQ-DEMO_ARTMODULES_ROOTAPPLICATION_MODULE  $ENV{ARTDAQ_DEMO_LIB}/libartdaq-demo_ArtModules_RootApplication_module.so )
      set( ARTDAQ-DEMO_ARTMODULES_WFVIEWER_MODULE  $ENV{ARTDAQ_DEMO_LIB}/libartdaq-demo_ArtModules_WFViewer_module.so )
      set( ARTDAQ-DEMO_ARTMODULES_CHECKINTEGRITY_MODULE  $ENV{ARTDAQ_DEMO_LIB}/libartdaq-demo_ArtModules_CheckIntegrity_module.so )
      set( ARTDAQ-DEMO_COMPRESSION  $ENV{ARTDAQ_DEMO_LIB}/libartdaq-demo_Compression.so )
      set( ARTDAQ-DEMO_GENERATORS_V172XFILEREADER_GENERATOR  $ENV{ARTDAQ_DEMO_LIB}/libartdaq-demo_Generators_V172xFileReader_generator.so )
      set( ARTDAQ-DEMO_GENERATORS_V172XSIMULATOR_GENERATOR  $ENV{ARTDAQ_DEMO_LIB}/libartdaq-demo_Generators_V172xSimulator_generator.so )
      set( ARTDAQ-DEMO_GENERATORS_TOYSIMULATOR_GENERATOR  $ENV{ARTDAQ_DEMO_LIB}/libartdaq-demo_Generators_ToySimulator_generator.so )
      set( ARTDAQ-DEMO_GENERATORS_ASCIISIMULATOR_GENERATOR  $ENV{ARTDAQ_DEMO_LIB}/libartdaq-demo_Generators_AsciiSimulator_generator.so )
      set( ARTDAQ-DEMO_GENERATORS_UDPRECEIVER_GENERATOR  $ENV{ARTDAQ_DEMO_LIB}/libartdaq-demo_Generators_UDPReceiver_generator.so )
      set( ARTDAQ-DEMO_GENERATORS_TOYHARDWAREINTERFACE  $ENV{ARTDAQ_DEMO_LIB}/libartdaq-demo_Generators_ToyHardwareInterface.so )
      set( ARTDAQ-DEMO_BUILDINFO  $ENV{ARTDAQ_DEMO_LIB}/libartdaq-demo_BuildInfo.so )
      include_directories ( $ENV{ARTDAQ_DEMO_INC} )

check_required_components(artdaq_demo)

